unit FIB_array;

interface
uses
  Types, Classes, SysUtils, Dialogs, Variants, Math, FMTBcd,
  DB, FIB_access, FIB_header, FIB_messages, CommonStuff;

type
  TFIBCustomArrayField = class;

  TFIB_array = class(TObject)
  private
  protected
    function InitializeArray(TableName, FieldName: string): Boolean;
    function GetArrayData(PArrayID: PGDS_QUAD): Boolean;
    procedure AssignArrayID(var aSQLVAR: TXSQLVAR;
                            ArrayElementSize: Word;
                            BufferSize: Cardinal;
                            Buffer: Pointer);
  public
    constructor Create(Field: TField; PDatabase: PFIB_Database; PTRHandle: PISC_TR_HANDLE);
    destructor Destroy; override;
    procedure Clear;
    procedure CopyFrom(Source: TObject);
    property DataBuffer: Pointer read FBuffer;
    property BufferSize: Cardinal read FBufferSize;
    property DimensionCount: ShortInt read GetDimensionCount;
    property ElementCount: Cardinal read FElementCount;
    property ElementSize: Word read FElementSize;
  end;


  TFIBCustomArrayField = class(TArrayField)
  private
  protected
    function GetDatabase: PFIB_Database; virtual; abstract;
    function GetTRHandle: PISC_TR_HANDLE; virtual; abstract;
    function GetAsVariant: Variant; override;
    function GetFieldValue(Index: Integer): Variant; override;
    procedure SetFieldValue(Index: Integer; const Value: Variant); override;
    procedure SetVarValue(const Value: Variant); override;
    procedure SetAsString(const Value: string); override;
    property FIB_array: TFIB_array read FFIB_array;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property ArrayID: TGDS_QUAD read GetArrayID;
    property DimensionCount: Byte read GetDimensionCount;
    property Bounds[Dimension: Byte]: TISC_ARRAY_BOUND read GetBounds;
    property FieldCount: Integer read GetFieldCount;
    property ElementCount: Cardinal read GetElementCount;
    property ElementDataType: TFieldType read GetElementDataType;
    property ElementValueByIndices[Indices: TSmallIntDynArray]: Variant
             read GetElementValueByIndices write SetElementValueByIndices;
    property ElementValueByNumber[ElementNumber: Cardinal]: Variant
             read GetElementValueByNumber write SetElementValueByNumber;
  end;


procedure ReadArrayField(sqldata: PChar; aFIB_Array: TFIB_Array); // in sqldata^ TGDS_QUAD

implementation

end.
